'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _DesktopComponent2 = require('./DesktopComponent');

var _DesktopComponent3 = _interopRequireDefault(_DesktopComponent2);

var _libuiNode = require('libui-node');

var _libuiNode2 = _interopRequireDefault(_libuiNode);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _yogaLayout = require('yoga-layout');

var _yogaLayout2 = _interopRequireDefault(_yogaLayout);

var _styleToYoga = require('../utils/styleToYoga');

var styleConverter = _interopRequireWildcard(_styleToYoga);

var _ = require('./');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

console.log(_yogaLayout.Node.create().getHeight());

var View = function (_DesktopComponent) {
  _inherits(View, _DesktopComponent);

  function View(root, props) {
    _classCallCheck(this, View);

    var _this = _possibleConstructorReturn(this, (View.__proto__ || Object.getPrototypeOf(View)).call(this, root, props));

    _this.node = _yogaLayout.Node.create();
    console.log(_yogaLayout.Node.create().getHeight());
    _this.root = root;
    _this.props = _extends({}, props);
    _this.setDefaults(props);
    _this.element = new _libuiNode2.default.UiFixed();
    _this.initialProps(_this.props);
    return _this;
  }

  _createClass(View, [{
    key: 'updateNodeSize',
    value: function updateNodeSize() {
      var size = void 0;
      if (this.parent instanceof _.Window) {
        size = this.parent.element.contentSize;
      } else {
        size = _libuiNode2.default.Ui.size(this.parent.element);
      }
      this.width = size.width;
      this.height = size.height;
      console.log(size);
      this.node.setWidth(size.width);
      this.node.setHeight(size.height);
    }
  }, {
    key: 'parseStyleFlexbox',
    value: function parseStyleFlexbox() {
      var _this2 = this;

      if (this.props.style) {
        Object.keys(this.props.style).map(function (key) {
          styleConverter[key](_this2.node, _this2.props.style[key]);
        });
      }
    }
  }, {
    key: 'addAllChildren',
    value: function addAllChildren() {
      for (var i = 0; i < this.children.length; i += 1) {
        this.children[i].node = _yogaLayout.Node.createDefault();
        var size = _libuiNode2.default.Ui.size(this.children[i].element);
        this.children[i].height = size.height;
        this.children[i].width = size.width;
        this.children[i].convertStyle();
        console.log(size);
        this.children[i].node.setWidth(size.width);
        this.children[i].node.setHeight(size.height);
        this.node.insertChild(this.children[i].node, i);
      }
    }
  }, {
    key: 'calcLayout',
    value: function calcLayout() {
      var directionMap = {
        ltr: _yogaLayout2.default.DIRECTION_LTR,
        rtl: _yogaLayout2.default.DIRECTION_RTL,
        inherit: _yogaLayout2.default.DIRECTION_INHERIT
      };
      var direction = void 0;
      if (this.props.style && 'direction' in this.props.style && this.props.style.direction in directionMap) {
        direction = directionMap[this.props.style.direction];
      } else {
        direction = directionMap['ltr'];
      }
      if (this.parent instanceof View) {
        // our parent is a view, so already called calculateLayout
        this.parent.calcLayout();
      } else {
        console.log(this.node);
        this.node.calculateLayout();
      }
    }
  }, {
    key: 'positionChildren',
    value: function positionChildren() {
      var self = this.node.getComputedLayout(); // set ourself width and height
      console.log(self.left);
      _libuiNode2.default.Ui.setSize(this.element, self.width, self.height); // if our parent is a View, it sets our position and size, else we can only set our size anyway
      for (var i = 0; i < this.children.length; i += 1) {
        // go through each of our children and size them
        var layout = this.children[i].node.getComputedLayout();
        this.element.append(this.children[i].element, layout.left, layout.top);
        _libuiNode2.default.Ui.setSize(this.children[i].element, layout.width, layout.height);
      }
    }
  }, {
    key: 'render',
    value: function render(parent) {
      this.parent = parent;
      this.node.reset(); // reset all properties in case they changed
      this.addParent(parent);
      this.updateNodeSize(); // set the view default size
      this.parseStyleFlexbox(); // convert all styles
      this.addAllChildren(); // add nodes to children
      this.renderChildNode(this); // place the children and call their render
      this.calcLayout(); // calculate the layout (traverses to root node and calculates layout)
      this.positionChildren(); // position and size the children
    }
  }]);

  return View;
}(_DesktopComponent3.default);

View.PropTypes = _extends({}, _DesktopComponent2.universalPropTypes, {
  style: _propTypes2.default.object
});

View.defaultProps = _extends({}, _DesktopComponent2.universalDefaultProps, {
  style: {}
});

exports.default = View;